=== debian/changelog ===
mumble (1.5.735-6) unstable; urgency=medium

  * Team upload

  [ Diederik de Haas ]
  * debian/patches: Add patch to fix building with GCC-15 (Closes: #1114216)

 -- Bastian Germann <bage@debian.org>  Tue, 16 Sep 2025 12:37:39 +0200

mumble (1.5.735-5) unstable; urgency=medium

  * debian/patches:
    - Add 50-fix-segfault-missing-pipewire-config.diff to fix Mumble Segfault
      when the PipeWire configuration is missing
      (Closes: #1091358, #1107868)
    - Update 90-debianize-systemd-unit.diff for Forwarding: not-needed

 -- Christopher Knadle <Chris.Knadle@coredump.us>  Mon, 30 Jun 2025 20:19:46 -0400

mumble (1.5.735-4) unstable; urgency=medium

  * debian/control:
    - Update Standards-Version to 4.7.2 (no changes needed)
  * debian/mumble.README.Debian:
    - Update to add guidance for Mumble client concerning notification settings
      (Closes: #1088608)
  * debian/patches:
    - Remove 35-add-dpkg-buildflags.diff as it can no longer be applied after
      build system switched to CMake
    - Add 15-update-mumble-manpage.diff to add two new RPC commands
      Forwarded upstream https://github.com/mumble-voip/mumble/issues/6802
      (Closes: #1103838)
      Thanks to Kevin Otte <nivex@nivex.net> for reporting the bug
    - Update 45-add-pid-location-hint.diff to for Forwarding: not-needed
  * debian/po:
    - Update pt.po (Closes: #1103466)
      Thanks to Américo Monteiro <a_monteiro@gmx.com> for the translation
    - Update pt_BR.po (Closes: 1103449)
      Thanks to Adriano Rafael Gomes <adrianorg@debian.org> for the translation
    - Update ro.po (Closes: #1101822)
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org> for the
      translation

 -- Christopher Knadle <Chris.Knadle@coredump.us>  Sat, 03 May 2025 17:07:10 -0400

mumble (1.5.735-3) unstable; urgency=medium

  * debian/control:
    - Update Standards-Version to 4.7.1 (no changes needed)
  * debian/extras:
    - Update TODO concerning compiler flags
  * debian/patches:
    - Merge patches for avoiding building link plugin on armel into
      06-export-architecture-cmake.diff
  * debian/mumble.install:
    - Update usr/lib/* entry with ${DEB_HOST_MULTIARCH} subdirectories to avoid
      including mumble-server config files unintentionally included
      (Closes: #1093661, #1093661)
      Thanks to Daniel Lange <DLange@debian.org> for the bug report and fix
  * debian/patches:
    - Update 06-export-architecture-cmake.diff to mark Forwarded tag as
      not-needed to avoid Lintian warning
  * debian/po:
    - Update Spanish traslation file, thanks to Jathan <jathan@debian.org>
      (Closes: #1093718)
    - Update no.po Dutch translation file
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>
      (Closes: #1094156)

 -- Christopher Knadle <Chris.Knadle@coredump.us>  Mon, 24 Feb 2025 12:20:32 -0500

mumble (1.5.735-2) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * debian/po/de.po: Update German debconf translation
    (Closes: #1092740)

  [ Christopher Knadle ]
  * debian/control:
    - Add build-depends on systemd-dev for better fix for #1068504
  * debian/extras:
    - Rename sysv-init.README -> sysvinit.README
    - Update TODO to complete/remove items related to #1068504,
      Upate concerning planned build hardening to cmake/compiler.cmake
  * debian/mumble-server.examples:
    - Update for sysv-init.README -> sysvinit.README
  * debian/mumble-server.install:
    - Update to allow pkgconfig to auto-find source files related to systemd
  * debian/patches:
    - Add 06-export-architecture-cmake.diff to export the build architecture
    - Add 08-avoid-link-plugin-armel.diff to avoid link plugin on armel
    - Update 45-add-pid-location-hint.diff to add patch author email address
    - Update 90-debianize-systemd-unit.diff to remove invalid header line
  * debian/rules:
    - Add CMake option for bundled renamenoise
    - Add CMake option for use-pkgconf-install-paths to allow pkgconf to find
      source files related to systemd, improved fix #1068504
    - Add variable to get mumble BUILD_NUMBER from Debian changelog
    - Add CMake Debian hardening variables

 -- Christopher Knadle <Chris.Knadle@coredump.us>  Sun, 19 Jan 2025 14:11:21 -0500

mumble (1.5.735-1) unstable; urgency=medium

  [ Diederik de Haas ]
  * New upstream release: https://www.mumble.info/blog/mumble-1.5.735/
  * New upstream release 1.5.735
    - debian/patches: Drop patches applied upstream
    - debian/rules: Update build number
    (Closes: #1089246)
  * debian/rules: Stop parsing d/changelog
  * debian/rules: Remove unused MAKEFILE and SOURCE_DIR variables
  * debian/rules: Sort configure params alphabetically
  * debian/rules: Switch to system libraries
  * debian/po/templates.pot: Several style fixes
  * debian/control: Update package description for Mumble server
  * debian/control: Drop debhelper Build-Depends
  * debian/upstream/signing-key.asc: update to upstream's 2024 key
  * debian/watch: Reformat watch file
  * debian/mumble-server.install: Update file locations
  * debian: Add systemd-tmpfiles support for Mumble Server
  * debian/copyright: Update for rnnoise-src -> renamenoise change

  [ Christopher Knadle ]
  * debian/extras:
    - Add mumble-server.postinst which references /etc/default/mumble-server
      for use with the non-default init script
    - Add sysv-init.README to document that these files are for running
      mumble-server with a non-default init system
    - Update TODO file on attempted sysuers file location work
  * debian/patches:
    - Update 90-debianize-systemd-unit.diff for line offset fuzz
  * debian/mumble-server.examples:
    - Add mumble-server.postinst that references /etc/default/mumble-server
    - Add sysv-init.README for information on files to use with alternate init
  * debian/mumble-server.install:
    - Update build file move from etc/sysconfig.d to etc/sysusers.d
  * debian/mumble-server.postinst:

