=== debian/control ===
Source: mumble
Section: sound
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Christopher Knadle <Chris.Knadle@coredump.us>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
 cmake,
 libasound2-dev,
 libavahi-compat-libdnssd-dev,
 libboost-dev (>= 1.42),
 libcap-dev [linux-any],
 libgl-dev,
 libjack-jackd2-dev,
 libmsgsl-dev,
 libogg-dev,
 libopus-dev,
 libpoco-dev,
 libprotobuf-dev,
 libprotoc-dev,
 libpulse-dev,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 libsndfile1-dev,
 libspeechd-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libssl-dev,
 libxi-dev,
 libzeroc-ice-dev,
 nlohmann-json3-dev,
 pkgconf,
 po-debconf,
 protobuf-compiler,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 systemd-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/mumble
Vcs-Git: https://salsa.debian.org/pkg-voip-team/mumble.git
Homepage: https://www.mumble.info

Package: mumble
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libqt5sql5-sqlite,
 lsb-release
Suggests: mumble-server,
 speech-dispatcher
Description: Low latency encrypted VoIP client
 Mumble is a low-latency, high quality voice chat program for gaming.
 It features noise suppression, encrypted connections for both voice
 and instant messaging, automatic gain control and low latency audio
 with support for multiple audio standards. Mumble includes an in-game
 overlay compatible with most open-source and commercial 3D applications.
 Mumble is just a client and uses a non-standard protocol. You will need
 a dedicated server to talk to other users. Server functionality is
 provided by the package "mumble-server".

Package: mumble-server
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 libqt5sql5-sqlite,
 sysvinit-utils (>= 2.96)
Description: Low latency encrypted VoIP server
 Mumble server is the VoIP server component for Mumble. Mumble server is
 installed in a system-wide fashion, but can also be run by individual
 users. Each mumble-server process supports multiple virtual servers,
 each with their own user base and channel list.
