=== debian/watch ===
version=4
opts="pgpmode=auto" \
https://dl.mumble.info/stable/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
